;;converted from Win64 msgbox example for solasm
;;You can get the original source from : http://www.oby.ro/sol_asm/files/sol_asm_2009_07_18_v29_03.zip
;;
;;Linker : golink.exe       (download from http://www.jorgon.freeserve.co.uk/Golink.zip  )
;;
;;Assemble with:
;;  nasm -fwin64 hello64.asm
;;  golink hello64.obj User32.dll


MB_OK equ 0h

BITS 64

global Start

extern MessageBoxA

segment .data

caption		db	"Win64",0
message		db	"Hello World!!",0

segment .code
Start:
	
	;----------------
	; prepare stack
	;----------------
	sub	rsp,8*5         ; 4 qwords for 4 parameters and 1 qword for return address.
	;------------------
	; message box
	;------------------
	mov	r9,MB_OK	; uType
	mov	r8,caption	; lpCaption
	mov	rdx,message	; lpText
	mov	rcx,0		; hWnd

	call	MessageBoxA
	
	;----------------
	;; clean up stack
	;----------------
	add rsp,8*5      
	
	ret
	